clear
clc

% run on the practice checkerboard files --> make sure current file only has the .dat practice files.

AllFiles = dir('*.dat');%Make a list of all the .dat files in the current folder
CBpractice=NaN(length(AllFiles), 3); %change to num of variables
for i = 1:length(AllFiles);% Loop through all the .dat files
    currentFile = AllFiles(i);
    FileName = currentFile.name;%get the name of the current file as a string
    SubData = importdata(FileName,' ',1);% open the file
    CBpractice_Data = SubData.data; %save as .mat file
    subjectnum = SubData.data(1,1) %get subID, leave unsilented so can see it running for each participant. 

% Practice block:
    % Column 1: subID
    % Column 2: target colour (1-blue, 2- yellow)
    % Column 3: checkerboard type (1= easy, majority of tiles = YELLOW,2= easy, majority of tiles = BLUE, 3= difficult, majority of tiles = YELLOW, 4= difficult, majority of tiles = BLUE)
    % Column 4: If they made a correct (1) or incorrect (0) response.
    % Column 5: what response participant made (1-pressed key,
    % 0-no key press) 
    % Column 6: RT. If no keypress = stored as NaN.

    
% set up holding variables
RT=CBpractice_Data(:,6);
acc=CBpractice_Data(:,4); % 1=correct, 0=incorrect 

corrRT=NaN(1,length(CBpractice_Data))' ;

corrRT(acc==1)=RT(acc==1);

%%Mean
practiceMeanRT=nanmean(corrRT);
%%SD
practiceSTDRT=nanstd(corrRT);

%%this creates a row on the summary for all subjects
    
CBpractice(subjectnum,1)= subjectnum; 
CBpractice(subjectnum,2)= practiceMeanRT;
CBpractice(subjectnum,3)= practiceSTDRT;
end
 
save('CBpractice_Data.mat', 'CBpractice');
    