clear
clc


filename = uigetfile('MultiSelect', 'on'); % choose what files to include for the data processing
i=1;
Summary=NaN(length(filename), 107); %change to num of variables

load CBpractice_Data; % NOTE need to have the CBpractice_Data.mat file in the current folder!
for data = 1:(length(filename)); %loop for each session
currentfile=char(filename(i));
load(currentfile);
subjectnum = Checkerboard_Data(1,1) %leave unsilented so you can see it is running

% How data is saved based on the task script coding:
%subject = currentfile(1:2);
%subjectnum = str2num(subject) %leave unsilented so you can see it is running

%Input: 'Checkerboard_Data'
% Experimental block:  
    % Column 1: subID
    % Column 2: Trial number
    % Column 3: type of trial (0-neutral block, 1- experimental condition)
    % Column 4: Threat (1) or safe (2) block
    % Column 5: target colour (1-blue, 2- yellow)
    % Column 6: checkerboard type 
    % Column 7: what experimental condition (1-reward go (GW), 2-reward no go (NGW), 3- punishment go (NGA), 4- punishment no go (GA))
    % Column 8: Type of coded outcome in trials file if pressed key (not for analysis)  
    % Column 9: Type of coded outcome in trials file if not pressed key (not for analysis) 
    % Column 10: Actual Outcome 
    % Column 11: what response participant made 
    % Column 12: If they made a correct (1) or incorrect (0) response (Accuracy)
    % Column 13: RT. If no keypress = stored as NaN.
    % Column 14 = ITI RT
    % Column 15: Mean RT from practice block. Set as the stim duration in
    % main task. 
        
%%set up holding variables
cond=Checkerboard_Data(:,4) ; 
trial=Checkerboard_Data(:,7) ;
acc=Checkerboard_Data(:,12) ;
RT=Checkerboard_Data(:,13)  ;
resp=Checkerboard_Data(:,11) ;
check=Checkerboard_Data(:,6) ; 
colour=Checkerboard_Data(:,5) ; 
neutral=Checkerboard_Data(:,3) ; % 0=neutral block, 1=experimental block

ThrRT=NaN(1,length(Checkerboard_Data))'   ;
SafRT=NaN(1,length(Checkerboard_Data))'   ;

ThrAcc=NaN(1,length(Checkerboard_Data))'  ;
SafAcc=NaN(1,length(Checkerboard_Data))'   ;

TGWRT=NaN(1,length(Checkerboard_Data))' ;
TGART=NaN(1,length(Checkerboard_Data))' ;
TNGWRT=NaN(1,length(Checkerboard_Data))' ;
TNGART=NaN(1,length(Checkerboard_Data))' ;

SGWRT=NaN(1,length(Checkerboard_Data))' ;
SGART=NaN(1,length(Checkerboard_Data))' ;
SNGWRT=NaN(1,length(Checkerboard_Data))' ;
SNGART=NaN(1,length(Checkerboard_Data))' ;

TGWAcc=NaN(1,length(Checkerboard_Data))' ;
TGAAcc=NaN(1,length(Checkerboard_Data))' ;
TNGWAcc=NaN(1,length(Checkerboard_Data))' ;
TNGAAcc=NaN(1,length(Checkerboard_Data))' ;

SGWAcc=NaN(1,length(Checkerboard_Data))' ;
SGAAcc=NaN(1,length(Checkerboard_Data))' ;
SNGWAcc=NaN(1,length(Checkerboard_Data))' ;
SNGAAcc=NaN(1,length(Checkerboard_Data))' ;

% RTs for Go trials only for each condition, T/S:
TRTGoTrialsGW=NaN(1,length(Checkerboard_Data))' ;   % threat go win - correct RTs for Go trials only 
TRTGoTrialsGA=NaN(1,length(Checkerboard_Data))' ;   % threat go avoid - correct RTs for Go trials only 
TRTGoTrialsNGW=NaN(1,length(Checkerboard_Data))' ;   % threat nogo win - correct RTs for Go trials only 
TRTGoTrialsNGA=NaN(1,length(Checkerboard_Data))' ;   % threat nogo avoid - correct RTs for Go trials only 

SRTGoTrialsGW=NaN(1,length(Checkerboard_Data))' ;  
SRTGoTrialsGA=NaN(1,length(Checkerboard_Data))' ;   
SRTGoTrialsNGW=NaN(1,length(Checkerboard_Data))' ;  
SRTGoTrialsNGA=NaN(1,length(Checkerboard_Data))' ;   

% Acc no go trials easy/diff
% threat
TAccNoGoTrialsGWhard=NaN(1,length(Checkerboard_Data))' ;   
TAccNoGoTrialsGAhard=NaN(1,length(Checkerboard_Data))' ; 
TAccNoGoTrialsNGWhard=NaN(1,length(Checkerboard_Data))' ; 
TAccNoGoTrialsNGAhard=NaN(1,length(Checkerboard_Data))' ; 
%Safe
SAccNoGoTrialsGWhard=NaN(1,length(Checkerboard_Data))' ; 
SAccNoGoTrialsGAhard=NaN(1,length(Checkerboard_Data))' ;  
SAccNoGoTrialsNGWhard=NaN(1,length(Checkerboard_Data))' ; 
SAccNoGoTrialsNGAhard=NaN(1,length(Checkerboard_Data))' ; 

% Acc for Go trials restricted to difficult trials (for response bias-signal detection theory)
% Threat
TAccGoTrialsGWhard=NaN(1,length(Checkerboard_Data))' ; 
TAccGoTrialsGAhard=NaN(1,length(Checkerboard_Data))' ; 
TAccGoTrialsNGWhard=NaN(1,length(Checkerboard_Data))' ; 
TAccGoTrialsNGAhard=NaN(1,length(Checkerboard_Data))' ; 
% Safe
SAccGoTrialsGWhard=NaN(1,length(Checkerboard_Data))' ; 
SAccGoTrialsGAhard=NaN(1,length(Checkerboard_Data))' ; 
SAccGoTrialsNGWhard=NaN(1,length(Checkerboard_Data))' ; 
SAccGoTrialsNGAhard=NaN(1,length(Checkerboard_Data))' ; 

%%
ThrRT(cond==1) = RT(cond==1) ;
SafRT(cond==2) = RT(cond==2) ;

ThrAcc(cond==1) = acc(cond==1) ; 
SafAcc(cond==2) = acc(cond==2) ;

TGWRT(trial==1) = ThrRT(trial==1) ; 
TGART(trial==4) = ThrRT(trial==4) ; % (1) reward go= Go to Win, (2) reward nogo= NoGo to Win, (3) punish go = NoGo to Avoid and (4) punish nogo = Go to Avoid.         
TNGWRT(trial==2) = ThrRT(trial==2) ;
TNGART(trial==3) = ThrRT(trial==3) ;

TGWAcc(trial==1) = ThrAcc(trial==1) ; 
TGAAcc(trial==4) = ThrAcc(trial==4) ;
TNGWAcc(trial==2) = ThrAcc(trial==2) ;
TNGAAcc(trial==3) = ThrAcc(trial==3) ;

SGWRT(trial==1) = SafRT(trial==1) ;
SGART(trial==4) = SafRT(trial==4) ;
SNGWRT(trial==2) = SafRT(trial==2) ;
SNGART(trial==3) = SafRT(trial==3) ;

SGWAcc(trial==1) = SafAcc(trial==1) ;
SGAAcc(trial==4) = SafAcc(trial==4) ;
SNGWAcc(trial==2) = SafAcc(trial==2) ;
SNGAAcc(trial==3) = SafAcc(trial==3) ;

%(1= easy, majority of tiles = YELLOW,2= easy, majority of tiles = BLUE, 3= difficult, majority of tiles = YELLOW, 4= difficult, majority of tiles = BLUE)
if colour(1)== 1 % target blue
 
    % RT GO TRIALS for all conditions
    % Threat
    TRTGoTrialsGW(check==2)=TGWRT(check==2);
    TRTGoTrialsGW(check==4)=TGWRT(check==4);
    TRTGoTrialsGA(check==2)=TGART(check==2);
    TRTGoTrialsGA(check==4)=TGART(check==4);
    TRTGoTrialsNGW(check==2)=TNGWRT(check==2);
    TRTGoTrialsNGW(check==4)=TNGWRT(check==4);
    TRTGoTrialsNGA(check==2)=TNGART(check==2);
    TRTGoTrialsNGA(check==4)=TNGART(check==4);
    % Safe
    SRTGoTrialsGW(check==2)=SGWRT(check==2);
    SRTGoTrialsGW(check==4)=SGWRT(check==4);
    SRTGoTrialsGA(check==2)=SGART(check==2);
    SRTGoTrialsGA(check==4)=SGART(check==4);
    SRTGoTrialsNGW(check==2)=SNGWRT(check==2);  
    SRTGoTrialsNGW(check==4)=SNGWRT(check==4);
    SRTGoTrialsNGA(check==2)=SNGART(check==2);
    SRTGoTrialsNGA(check==4)=SNGART(check==4);
    
    % Acc for NoGo trials hard
    % Threat
    TAccNoGoTrialsGWhard(check==3)=TGWAcc(check==3);
    TAccNoGoTrialsGAhard(check==3)=TGAAcc(check==3);
    TAccNoGoTrialsNGWhard(check==3)=TNGWAcc(check==3);
    TAccNoGoTrialsNGAhard(check==3)=TNGAAcc(check==3);
    %Safe
    SAccNoGoTrialsGWhard(check==3)=SGWAcc(check==3);
    SAccNoGoTrialsGAhard(check==3)=SGAAcc(check==3);
    SAccNoGoTrialsNGWhard(check==3)=SNGWAcc(check==3);
    SAccNoGoTrialsNGAhard(check==3)=SNGAAcc(check==3);

    % Accuracy Go for difficult trials only 
    TAccGoTrialsGWhard(check==4)=TGWAcc(check==4); 
    TAccGoTrialsGAhard(check==4)=TGAAcc(check==4); 
    TAccGoTrialsNGWhard(check==4)=TNGWAcc(check==4);
    TAccGoTrialsNGAhard(check==4)=TNGAAcc(check==4); 
    % Safe
    SAccGoTrialsGWhard(check==4)=SGWAcc(check==4);
    SAccGoTrialsGAhard(check==4)=SGAAcc(check==4);
    SAccGoTrialsNGWhard(check==4)=SNGWAcc(check==4);
    SAccGoTrialsNGAhard(check==4)=SNGAAcc(check==4);
    
else % target yellow

    %RT Go trials
    TRTGoTrialsGW(check==1)=TGWRT(check==1);
    TRTGoTrialsGW(check==3)=TGWRT(check==3);
    TRTGoTrialsGA(check==1)=TGART(check==1);
    TRTGoTrialsGA(check==3)=TGART(check==3);
    TRTGoTrialsNGW(check==1)=TNGWRT(check==1);
    TRTGoTrialsNGW(check==3)=TNGWRT(check==3);
    TRTGoTrialsNGA(check==1)=TNGART(check==1);
    TRTGoTrialsNGA(check==3)=TNGART(check==3);
    
    SRTGoTrialsGW(check==1)=SGWRT(check==1);
    SRTGoTrialsGW(check==3)=SGWRT(check==3);
    SRTGoTrialsGA(check==1)=SGART(check==1);
    SRTGoTrialsGA(check==3)=SGART(check==3);
    SRTGoTrialsNGW(check==1)=SNGWRT(check==1);  
    SRTGoTrialsNGW(check==3)=SNGWRT(check==3);
    SRTGoTrialsNGA(check==1)=SNGART(check==1);
    SRTGoTrialsNGA(check==3)=SNGART(check==3);
    
    % Acc for NoGo trials hard for all conditions
    % Threat 
    TAccNoGoTrialsGWhard(check==4)=TGWAcc(check==4);  
    TAccNoGoTrialsGAhard(check==4)=TGAAcc(check==4);
    TAccNoGoTrialsNGWhard(check==4)=TNGWAcc(check==4);
    TAccNoGoTrialsNGAhard(check==4)=TNGAAcc(check==4);
    
    %Safe 
    SAccNoGoTrialsGWhard(check==4)=SGWAcc(check==4); 
    SAccNoGoTrialsGAhard(check==4)=SGAAcc(check==4); 
    SAccNoGoTrialsNGWhard(check==4)=SNGWAcc(check==4); 
    SAccNoGoTrialsNGAhard(check==4)=SNGAAcc(check==4); 
   
    % Accuracy Go for hard trials only 
    %threat
    TAccGoTrialsGWhard(check==3)=TGWAcc(check==3); 
    TAccGoTrialsGAhard(check==3)=TGAAcc(check==3); 
    TAccGoTrialsNGWhard(check==3)=TNGWAcc(check==3);
    TAccGoTrialsNGAhard(check==3)=TNGAAcc(check==3); 
    % Safe
    SAccGoTrialsGWhard(check==3)=SGWAcc(check==3);
    SAccGoTrialsGAhard(check==3)=SGAAcc(check==3);
    SAccGoTrialsNGWhard(check==3)=SNGWAcc(check==3);
    SAccGoTrialsNGAhard(check==3)=SNGAAcc(check==3);

end

%Number of nogo errors in each condition

%threat
ErrorNogoGWt=(sum(~isnan(TAccNoGoTrialsGWhard)))-(nansum(TAccNoGoTrialsGWhard));
ErrorNogoGAt=(sum(~isnan(TAccNoGoTrialsGAhard)))-(nansum(TAccNoGoTrialsGAhard));
ErrorNogoNGWt=(sum(~isnan(TAccNoGoTrialsNGWhard)))-(nansum(TAccNoGoTrialsNGWhard));
ErrorNogoNGAt=(sum(~isnan(TAccNoGoTrialsNGAhard)))-(nansum(TAccNoGoTrialsNGAhard));

%safe
ErrorNogoGWs=(sum(~isnan(SAccNoGoTrialsGWhard)))-(nansum(SAccNoGoTrialsGWhard));
ErrorNogoGAs=(sum(~isnan(SAccNoGoTrialsGAhard)))-(nansum(SAccNoGoTrialsGAhard));
ErrorNogoNGWs=(sum(~isnan(SAccNoGoTrialsNGWhard)))-(nansum(SAccNoGoTrialsNGWhard));
ErrorNogoNGAs=(sum(~isnan(SAccNoGoTrialsNGAhard)))-(nansum(SAccNoGoTrialsNGAhard));


%% MeanRT
%Mean RT Go
MeanGoThrGoWinRT=nanmean(TRTGoTrialsGW);
MeanGoThrGoAvoRT=nanmean(TRTGoTrialsGA);
MeanGoThrNoGoWinRT=nanmean(TRTGoTrialsNGW);
MeanGoThrNoGoAvoRT=nanmean(TRTGoTrialsNGA);

MeanGoSafGoWinRT=nanmean(SRTGoTrialsGW);
MeanGoSafGoAvoRT=nanmean(SRTGoTrialsGA);
MeanGoSafNoGoWinRT=nanmean(SRTGoTrialsNGW);
MeanGoSafNoGoAvoRT=nanmean(SRTGoTrialsNGA);

% Normalised means based on PRACTICE: calculate z-scores = (conditionMean -practiceMean)/practiceSD
NormZMeanRTGoThrGW=(MeanGoThrGoWinRT-CBpractice(subjectnum,2))/CBpractice(subjectnum,3);
NormZMeanRTGoThrGA=(MeanGoThrGoAvoRT-CBpractice(subjectnum,2))/CBpractice(subjectnum,3);
NormZMeanRTGoThrNGW=(MeanGoThrNoGoWinRT-CBpractice(subjectnum,2))/CBpractice(subjectnum,3);
NormZMeanRTGoThrNGA=(MeanGoThrNoGoAvoRT-CBpractice(subjectnum,2))/CBpractice(subjectnum,3);

NormZMeanRTGoSafGW=(MeanGoSafGoWinRT-CBpractice(subjectnum,2))/CBpractice(subjectnum,3);
NormZMeanRTGoSafGA=(MeanGoSafGoAvoRT-CBpractice(subjectnum,2))/CBpractice(subjectnum,3);
NormZMeanRTGoSafNGW=(MeanGoSafNoGoWinRT-CBpractice(subjectnum,2))/CBpractice(subjectnum,3);
NormZMeanRTGoSafNGA=(MeanGoSafNoGoAvoRT-CBpractice(subjectnum,2))/CBpractice(subjectnum,3);

%% Signal detection theory - measures

%Hit rate = number correct go/all go trials

%threat
HitGoWinT=(nansum(TAccGoTrialsGWhard))/((sum(~isnan(TAccGoTrialsGWhard))));
HitGoAvoT=(nansum(TAccGoTrialsGAhard))/((sum(~isnan(TAccGoTrialsGAhard))));
HitNoGoWinT=(nansum(TAccGoTrialsNGWhard))/((sum(~isnan(TAccGoTrialsNGWhard)))); 
HitNoGoAvoT=(nansum(TAccGoTrialsNGAhard))/((sum(~isnan(TAccGoTrialsNGAhard))));
%safe
HitGoWinS=(nansum(SAccGoTrialsGWhard))/((sum(~isnan(SAccGoTrialsGWhard))));
HitGoAvoS=(nansum(SAccGoTrialsGAhard))/((sum(~isnan(SAccGoTrialsGAhard))));
HitNoGoWinS=(nansum(SAccGoTrialsNGWhard))/((sum(~isnan(SAccGoTrialsNGWhard))));
HitNoGoAvoS=(nansum(SAccGoTrialsNGAhard))/((sum(~isnan(SAccGoTrialsNGAhard))));

%False alarm rate = number of nogo errors/all nogo trials
%threat
FAgoWinT=(ErrorNogoGWt)/((sum(~isnan(TAccNoGoTrialsGWhard))));
FAgoAvoT=(ErrorNogoGAt)/((sum(~isnan(TAccNoGoTrialsGAhard))));
FAnoGoWinT=(ErrorNogoNGWt)/((sum(~isnan(TAccNoGoTrialsNGWhard))));
FAnoGoAvoT=(ErrorNogoNGAt)/((sum(~isnan(TAccNoGoTrialsNGAhard))));
% safe
FAgoWinS=(ErrorNogoGWs)/((sum(~isnan(SAccNoGoTrialsGWhard))));
FAgoAvoS=(ErrorNogoGAs)/((sum(~isnan(SAccNoGoTrialsGAhard))));
FAnoGoWinS=(ErrorNogoNGWs)/((sum(~isnan(SAccNoGoTrialsNGWhard))));
FAnoGoAvoS=(ErrorNogoNGAs)/((sum(~isnan(SAccNoGoTrialsNGAhard))));

% HR and FAR adjusted with the 'loglinear' approach for the response bias calculation: (Hautus, 1995): add 0.5 to all hits (correct go) and +1 to all go
%trials to deal with 0s and 1s for the response bias analysis.

% Hit rates adjusted
%threat 
HRGWtAdj=((nansum(TAccGoTrialsGWhard)+0.5))/((sum(~isnan(TAccGoTrialsGWhard)))+1);
HRGAtAdj=((nansum(TAccGoTrialsGAhard)+0.5))/((sum(~isnan(TAccGoTrialsGAhard)))+1);
HRNGWtAdj=((nansum(TAccGoTrialsNGWhard)+0.5))/((sum(~isnan(TAccGoTrialsNGWhard)))+1); 
HRNGAtAdj=((nansum(TAccGoTrialsNGAhard)+0.5))/((sum(~isnan(TAccGoTrialsNGAhard)))+1);
%safe
HRGWsAdj=((nansum(SAccGoTrialsGWhard)+0.5))/((sum(~isnan(SAccGoTrialsGWhard)))+1);
HRGAsAdj=((nansum(SAccGoTrialsGAhard)+0.5))/((sum(~isnan(SAccGoTrialsGAhard)))+1);
HRNGWsAdj=((nansum(SAccGoTrialsNGWhard)+0.5))/((sum(~isnan(SAccGoTrialsNGWhard)))+1);
HRNGAsAdj=((nansum(SAccGoTrialsNGAhard)+0.5))/((sum(~isnan(SAccGoTrialsNGAhard)))+1);

%False alarm rates adjusted 
% threat
FARGWtAdj=(ErrorNogoGWt+0.5)/((sum(~isnan(TAccNoGoTrialsGWhard)))+1);
FARGAtAdj=(ErrorNogoGAt+0.5)/((sum(~isnan(TAccNoGoTrialsGAhard)))+1);
FARNGWtAdj=(ErrorNogoNGWt+0.5)/((sum(~isnan(TAccNoGoTrialsNGWhard)))+1);
FARNGAtAdj=(ErrorNogoNGAt+0.5)/((sum(~isnan(TAccNoGoTrialsNGAhard)))+1);
% safe
FARGWsAdj=(ErrorNogoGWs+0.5)/((sum(~isnan(SAccNoGoTrialsGWhard)))+1);
FARGAsAdj=(ErrorNogoGAs+0.5)/((sum(~isnan(SAccNoGoTrialsGAhard)))+1);
FARNGWsAdj=(ErrorNogoNGWs+0.5)/((sum(~isnan(SAccNoGoTrialsNGWhard)))+1);
FARNGAsAdj=(ErrorNogoNGAs+0.5)/((sum(~isnan(SAccNoGoTrialsNGAhard)))+1);

% response bias: c: 
% -0.5((z(HR))+(z(FAR))

%threat 
c_GWth=-0.5*((norminv(HRGWtAdj))+(norminv(FARGWtAdj)));
c_GAth=-0.5*((norminv(HRGAtAdj))+(norminv(FARGAtAdj)));
c_NGWth=-0.5*((norminv(HRNGWtAdj))+(norminv(FARNGWtAdj)));
c_NGAth=-0.5*((norminv(HRNGAtAdj))+(norminv(FARNGAtAdj)));
%safe
c_GWsafe=-0.5*((norminv(HRGWsAdj))+(norminv(FARGWsAdj)));
c_GAsafe=-0.5*((norminv(HRGAsAdj))+(norminv(FARGAsAdj)));
c_NGWsafe=-0.5*((norminv(HRNGWsAdj))+(norminv(FARNGWsAdj)));
c_NGAsafe=-0.5*((norminv(HRNGAsAdj))+(norminv(FARNGAsAdj)));


%%this creates a row on the summary for all subjects
Summary(subjectnum,1)= subjectnum;
Summary(subjectnum,2)=NormZMeanRTGoThrGW;
Summary(subjectnum,3)=NormZMeanRTGoThrGA;
Summary(subjectnum,4)=NormZMeanRTGoThrNGW;
Summary(subjectnum,5)=NormZMeanRTGoThrNGA;
Summary(subjectnum,6)=NormZMeanRTGoSafGW;
Summary(subjectnum,7)=NormZMeanRTGoSafGA;
Summary(subjectnum,8)=NormZMeanRTGoSafNGW;
Summary(subjectnum,9)=NormZMeanRTGoSafNGA;
Summary(subjectnum,10)=HitGoWinT;
Summary(subjectnum,11)=HitGoAvoT;
Summary(subjectnum,12)=HitNoGoWinT;
Summary(subjectnum,13)=HitNoGoAvoT;
Summary(subjectnum,14)=HitGoWinS;
Summary(subjectnum,15)=HitGoAvoS;
Summary(subjectnum,16)=HitNoGoWinS;
Summary(subjectnum,17)=HitNoGoAvoS;
Summary(subjectnum,18)=FAgoWinT;
Summary(subjectnum,19)=FAgoAvoT;
Summary(subjectnum,20)=FAnoGoWinT;
Summary(subjectnum,21)=FAnoGoAvoT;
Summary(subjectnum,22)=FAgoWinS;
Summary(subjectnum,23)=FAgoAvoS;
Summary(subjectnum,24)=FAnoGoWinS;
Summary(subjectnum,25)=FAnoGoAvoS;
Summary(subjectnum,26)=c_GWth;
Summary(subjectnum,27)=c_GAth;
Summary(subjectnum,28)=c_NGWth;
Summary(subjectnum,29)=c_NGAth;
Summary(subjectnum,30)=c_GWsafe;
Summary(subjectnum,31)=c_GAsafe;
Summary(subjectnum,32)=c_NGWsafe;
Summary(subjectnum,33)=c_NGAsafe;
i=i+1;
end

csvwrite('ReinforcedGoNoGoSummary_DATE.csv',Summary); % save master
%spreadsheet


